<template>
    <b-container>
        <Bar
        :chart-options="chartOptions"
        :chart-data="chartData"
        :chart-id="chartId"
        :dataset-id-key="datasetIdKey"
        :plugins="plugins"
        :css-classes="cssClasses"
        :styles="styles"
        :width="width"
        :height="height"
        />
    </b-container>
</template>


<script>
import { Bar } from 'vue-chartjs'
import { Chart as ChartJS, Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale } from 'chart.js'
ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale)

export default {
    name: 'BarChartComponent',
    components: { Bar },
    props: {
        chartId: {
            type: String,
            default: 'bar-chart'
        },
        datasetIdKey: {
            type: String,
            default: 'label'
        },
        width: {
            type: Number,
            default: 400
        },
        height: {
            type: Number,
            default: 400
        },
        cssClasses: {
            default: '',
            type: String
        },
        styles: {
            type: Object,
            default: () => {}
        },
        plugins: {
            type: Object,
            default: () => {}
        },
    },
    data () {
        return {
            chartData: tweets.data,
            chartOptions: tweets.options
        }
    },
    mounted() {
        this.$root.$on("getDataBarChart", tweet_array => {
            let days = []
            let n_tweets = []
            for ( const tweet of tweet_array) {
                let temp = tweet;
                days.push(temp[0])
                n_tweets.push(temp[1])
            }
            tweets.data.labels = days;
            tweets.data.datasets[0].data = n_tweets;
            this.chartData = tweets.data;
            this.chartOptions = tweets.options;
            return (tweets);
        });
    }
}

let tweets = {
    data: {
        labels: [],
        datasets: [ { 
            data: [],
            backgroundColor: "#2596be",
            borderWidth: 3,
            label: "Numero dei tweet al giorno"
        } ]
    },
    options: { 
        responsive : true,
        plugins: {
            legend: {
                display: true
            }
        }
    }
}

</script>
